C
Code by Michael Kupferschmid
C
C     This program changes all occurrences of one string to another.
C     It is harder to use than changeall, but the strings can
C     include more characters that are meaningful to the shell.
C
C     variable  meaning
C     --------  -------
C     EXIT      system routine stops program with a return code
C     FINDST    routine finds starting location of a substring
C     GETFIL    routine attaches a file for a given purpose
C     K         index on the characters of a string
C     KSTART    index in LINE where an instance of OLD was found
C     LENGTH    function returns index of last nonblank in a string
C     LINE      a text line being processed
C     LL        length of LINE
C     LN        length of NEW
C     LO        length of OLD
C     NEW       new string
C     OLD       old string
C     PROMPT    routine prompts for input from the keyboard
C     SHIFTL    routine removes leading blanks from a string
C     SHIFTR    routine makes string flush right in its length
C
      CHARACTER*1 OLD(80),NEW(80),LINE(80)
C
C ------------------------------------------------------------------
C
C     get the files
      CALL GETFIL('input',5,' ',0,1,1)
      CALL GETFIL('output',6,' ',0,2,2)
C
C     get the strings
      CALL PROMPT('old:',4)
      READ(5,900,END=1) OLD
      LO=LENGTH(OLD,80)
      CALL PROMPT('new:',4)
      READ(5,900,END=1) NEW
      LN=LENGTH(NEW,80)
C
C     copy a line unchanged if it is blank or empty of OLD
    3 READ(1,900,END=2) LINE
  900 FORMAT(80A1)
      LL=LENGTH(LINE,80)
    6 IF(LL.EQ.0) THEN
         WRITE(2,900)
         GO TO 3
      ENDIF
      CALL FINDST(LINE,LL,OLD,LO, KSTART)
      IF(KSTART.LE.0) THEN
         WRITE(2,900) (LINE(K),K=1,LL)
         GO TO 3
      ENDIF
C
C     an instance of OLD was found; replace it
C        blank the old string
         DO 4 K=1,LO
              LINE(KSTART+K-1)=' '
    4    CONTINUE
C
C        remove the space it occupied
         CALL SHIFTL(LINE(KSTART),LL-KSTART+1)
C
C        open space for the new string
         CALL SHIFTR(LINE(KSTART),(LL-KSTART+1)+(LN-LO))
C
C        copy in the new string
         DO 5 K=1,LN
              LINE(KSTART+K-1)=NEW(K)
    5    CONTINUE
         LL=LL+(LN-LO)
C
C     and check again for more instances
      GO TO 6
C
C     an EOF was sent in response to a prompt
    1 CALL EXIT(1)
C
C     the end of the input file has been reached
    2 CALL EXIT(0)
      END
